<script src="@#file#(math.min.js)" type="text/javascript"></script>
<script src="@#file#(bezier.js)"   type="text/javascript"></script>

<p>Promotrimo krivulju definiranu s dvije točke: početnom točkom \(\vec r_0 \) i završnom točkom \(\vec r_1 \), koja predstavlja linijski segment (tj. poseban slučaj krivulje). Pretpostavimo da sve točke te krivulje želimo zapisati u parametarskom obliku, pri čemu će parametar biti \( t \). Točku kroz koju krivulja prolazi za neku vrijednost parametra \( t \) označit ćemo s \(\vec p(t)\). Parametar pri tome želimo mijenjati od 0 do 1, te želimo da je \(\vec p(0) = \vec r_0\) i da je \(\vec p(1) = \vec r_1\). Za vrijednosti parametra \(t\) koje su između 0 i 1 želimo dobiti različite točke krivulje.</p>

<p>Kako se radi o linijskom segmentu, svaku točku krivulje možemo zapisati kao početka točka plus skalirani vektor koji iz početne točke gleda u završnu točku:

\[
\begin{align*}
  \vec p(t) &amp;= \vec r_0 + (\vec r_1 - \vec r_0) \cdot t \\
            &amp;= \vec r_0 + \vec r_1 \cdot t - \vec r_0 \cdot t \\
            &amp;= (1 - t) \cdot \vec r_0 +  t \cdot \vec r_1
\end{align*}
\]
Ovaj posljednji oblik, \(\vec p(t) = (1 - t) \cdot \vec r_0 +  t \cdot \vec r_1\) definira točku \(\vec p(t)\) kao linearnu interpolaciju između točaka \(\vec r_0 \) i \(\vec r_1 \). Primijetite: kad je \(t=0\), dobivamo \(\vec p(t) = \vec r_0 \), kad je \(t=1\), dobivamo \(\vec p(t) = \vec r_1 \), kad je \(t=1/2\), dobivamo \(\vec p(t) = (\vec r_0 + \vec r_1)/2\), itd. Primjer u nastavku ovo ilustrira. Točka \(\vec r_0\) je lijeva a \(\vec r_1\) je desna.</p>

<p>Vrijednost parametra \(t\) možete mijenjati uporabom kontrole prikazane ispod donjeg grafa. Ispod grafa možete uključiti i prikaz nastale krivulje. Mišem možete pomicati i zadane točke \(\vec r_i\).</p>

  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas1" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez1 = new drawInterpolationBezier("myCanvas1");
    bez1.addingEnabled = false;
    bez1.buildProc = true;
    bez1.setAllPoints([[68,253],[737,71]]);
    bez1.paint();
  </script>
  <input type="checkbox" onclick="bez1.curveApprox=this.checked; bez1.paint();"> Aproksimacijska krivulja<br>
  <table>
  <tr><td align="right">0</td><td><input type="range" min="0" max="1" step="0.01" value="0" onchange="bez1.tvalue=this.value; document.getElementById('bezBuild1').innerHTML=this.value; bez1.paint();" oninput="bez1.tvalue=this.value; document.getElementById('bezBuild1').innerHTML=this.value; bez1.paint();"></td><td>1  (vrijednost t = <span id="bezBuild1">0</span>)</td></tr>
  </table>

<p>Promotrimo sada slučaj kada su zadane tri točke: \(\vec r_0\), \(\vec r_1\) i \(\vec r_2\). Želimo krivulju koja počinje u \(\vec r_0\) (za \(t=0\)) a završava u \(\vec r_2\) (za \(t=1\)). Točke krivulje pri tome ćemo definirati na sljedeći način: promotrimo krivulju koju definiraju točke \(\vec r_0\) i \(\vec r_1\) te krivulju koju definiraju točke \(\vec r_1\) i \(\vec r_2\). Točka kroz koju će konačna krivulja proći odgovarat će linearnoj interpolaciji ovih jednostavnijih krivulja. Možemo pisati:
\[
\begin{align*}
  \vec A(t) &amp;= (1-t) \cdot \vec r_0 + t \cdot \vec r_1 \\
  \vec B(t) &amp;= (1-t) \cdot \vec r_1 + t \cdot \vec r_2 \\
  \vec p(t) &amp;= (1-t) \cdot \vec A(t) + t \cdot \vec B(t) \\
\end{align*}
\]
Uvrštavanjem dalje dobivamo:
\[
\begin{align*}
  \vec p(t) &amp;= (1-t) \cdot ((1-t) \cdot \vec r_0 + t \cdot \vec r_1) + t \cdot ((1-t) \cdot \vec r_1 + t \cdot \vec r_2) \\
            &amp;= (1-t)^2 \cdot \vec r_0 + (1-t) t \cdot \vec r_1 + (1-t) t \cdot \vec r_1 + t^2 \cdot \vec r_2 \\
            &amp;= (1-t)^2 \cdot \vec r_0 + 2 \cdot (1-t) t \cdot \vec r_1 + t^2 \cdot \vec r_2
\end{align*}
\]
Primijetite još jednom postupak konstrukcije: krivulja je zadana s tri točke - \(\vec r_0\), \(\vec r_1\) i \(\vec r_2\).
Točke \(\vec r_0\) i \(\vec r_1\) pri tome definiraju jednu linearnu krivulju (i za svaku vrijednost parametra \(t\)
točno možemo odrediti u kojoj smo točki te krivulje). Točke \(\vec r_1\) i \(\vec r_2\) definiraju drugu linearnu krivulju 
(i za svaku vrijednost parametra \(t\) točno možemo odrediti u kojoj smo točki te krivulje). Kvadratna aproksimacijska
Bezierova krivulja linearna je interpolacija tih dviju jednostavnijih krivulja.
</p>
<p>Primjer kvadratne aproksimacijske Bezierove krivulje prikazan je u nastavku. Učinite sljedeće.</p>
<ol>
<li>Kliznikom ispod demonstracije prođite kroz vrijednosti parametra \(t\) od 0 do 1 i uočite put koji opisuje
    točka prikazana ljubičastim rombom - to je točka krivulje za podešenu vrijednost parametra \(t\).</li>
<li>Uočite i točke koje se dobivaju linearnom interpolacijom točaka \(\vec r_0\) i \(\vec r_1\) te linearnom
    interpolacijom točaka \(\vec r_1\) i \(\vec r_2\).</li>
<li>Uključite prikaz tih jednostavnijih krivulja.</li>
<li>Uočite da je konačna točka opet linearna interpolacija točaka koje leže na dvama linearnim krivuljama.</li>
<li>Uključite prikaz konačne aproksimacijske krivulje koja se dobiva.</li>
</ol>

  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas2" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez2 = new drawInterpolationBezier("myCanvas2");
    bez2.addingEnabled = false;
    bez2.buildProc = true;
    bez2.setAllPoints([[56,258],[202,26],[741,233]]);
    bez2.paint();
  </script>
  <input type="checkbox" onclick="bez2.curveApprox=this.checked; bez2.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez2.showSimplerApprox=this.checked; bez2.paint();"> Prikaži linearne krivulje čija je konačna krivulja linearna interpolacija<br>
  <table>
  <tr><td align="right">0</td><td><input type="range" min="0" max="1" step="0.01" value="0" onchange="bez2.tvalue=this.value; document.getElementById('bezBuild2').innerHTML=this.value; bez2.paint();" oninput="bez2.tvalue=this.value; document.getElementById('bezBuild2').innerHTML=this.value; bez2.paint();"></td><td>1  (vrijednost t = <span id="bezBuild2">0</span>)</td></tr>
  </table>

<p>Pogledajmo još samo jedan složeniji primjer: krivulju zadanu točkama \(\vec r_0\), \(\vec r_1\), \(\vec r_2\) i \(\vec r_3\) pri čemu želimo da krivulja započinje u točki \(\vec r_0\) a završava u točki \(\vec r_3\). Konstrukciju ćemo napraviti slično kao u prethodnom slučaju. Najprije ćemo razmotriti tri jednostavne krivulje: \(\vec A(t)\) koja predstavlja linearnu interpolaciju između \(\vec r_0\) i \(\vec r_1\), \(\vec B(t)\) koja predstavlja linearnu interpolaciju između \(\vec r_1\) i \(\vec r_2\) te \(\vec C(t)\) koja predstavlja linearnu interpolaciju između \(\vec r_2\) i \(\vec r_3\). Potom ćemo definirati da je \(\vec D(t)\) linearna interpolacija između \(\vec A(t)\) i \(\vec B(t)\) te da je \(\vec E(t)\) linearna interpolacija između \(\vec B(t)\) i \(\vec C(t)\). Konačno, točka kroz koju prolazi krivulja bit će jednaka linearnoj interpolaciji između \(\vec D(t)\) i \(\vec E(t)\). Idemo to izračunati.

\[
\begin{align*}
  \vec A(t) &amp;= (1-t) \cdot \vec r_0 + t \cdot \vec r_1 \\
  \vec B(t) &amp;= (1-t) \cdot \vec r_1 + t \cdot \vec r_2 \\
  \vec C(t) &amp;= (1-t) \cdot \vec r_2 + t \cdot \vec r_3 \\
  \vec D(t) &amp;= (1-t) \cdot \vec A(t) + t \cdot \vec B(t) \\
            &amp;= (1-t)^2 \cdot \vec r_0 + 2 \cdot (1-t) t \cdot \vec r_1 + t^2 \cdot \vec r_2 \\
  \vec E(t) &amp;= (1-t) \cdot \vec B(t) + t \cdot \vec C(t) \\
            &amp;= (1-t)^2 \cdot \vec r_1 + 2 \cdot (1-t) t \cdot \vec r_2 + t^2 \cdot \vec r_3 \\
  \vec p(t) &amp;= (1-t) \cdot \vec D(t) + t \cdot \vec E(t) \\
            &amp;= (1-t)^3 \cdot \vec r_0 + 3 \cdot (1-t)^2 t \cdot \vec r_1 + 3 \cdot (1-t) t^2 \cdot \vec r_2 + t^3 \cdot \vec r_3\\
\end{align*}
\]
Uočite da \(\vec D(t)\) predstavlja kvadratnu aproksimacijsku Bezierovu krivulju određenu točkama \(\vec r_0\), \(\vec r_1\) i \(\vec r_2\), a \(\vec E(t)\) kvadratnu aproksimacijsku Bezierovu krivulju određenu točkama \(\vec r_1\), \(\vec r_2\) i \(\vec r_3\). Naša kubna aproksimacijska Bezierova krivlja zapravo je linearna interpolacija između ove dvije jednostavnije krivulje.  
</p>
<p>
Primjer kubne aproksimacijske Bezierove krivulje ilustriran je u nastavku. Uočite na njemu točke \(\vec D(t)\) i \(\vec E(t)\) i uočite da je konačna točka upravo (prema samoj konstrukciji) linearna interpolacija između njih.
</p>

<p>Na danoj demonstraciji učinite sljedeće.</p>
<ol>
<li>Kliznikom ispod demonstracije prođite kroz vrijednosti parametra \(t\) od 0 do 1 i uočite put koji opisuje
    točka prikazana ljubičastim rombom - to je točka krivulje za podešenu vrijednost parametra \(t\).</li>
<li>Uočite i dvije kvadratne Bezierove aproksimacijske krivulje koje se dobivaju za točke \(\vec r_0\), \(\vec r_1\) i \(\vec r_2\) te za točke 
    \(\vec r_1\), \(\vec r_2\) i \(\vec r_3\).</li>
<li>Uključite prikaz tih jednostavnijih krivulja.</li>
<li>Uočite da je konačna točka opet linearna interpolacija točaka koje leže na tim kvadratnim krivuljama.</li>
<li>Uključite prikaz konačne kubne aproksimacijske Bezierove krivulje koja se dobiva.</li>
</ol>

  <div style="width: 800px; height: 300px; position:relative;">
  <canvas id="myCanvas3" width="800" height="300" style="border: 1px solid black;"></canvas>
  </div>
  <script type="text/javascript">
    var bez3 = new drawInterpolationBezier("myCanvas3");
    bez3.addingEnabled = false;
    bez3.showSimplerApprox = false;
    bez3.buildProc = true;
    bez3.setAllPoints([[51,251],[25,27],[423,247],[780,19]]);
    bez3.paint();
  </script>
  <input type="checkbox" onclick="bez3.curveApprox=this.checked; bez3.paint();"> Aproksimacijska krivulja<br>
  <input type="checkbox" onclick="bez3.showSimplerApprox=this.checked; bez3.paint();"> Prikaži kvadratne krivulje čija je konačna krivulja linearna interpolacija<br>
  <table>
  <tr><td align="right">0</td><td><input type="range" min="0" max="1" step="0.01" value="0" onchange="bez3.tvalue=this.value; document.getElementById('bezBuild3').innerHTML=this.value; bez3.paint();" oninput="bez3.tvalue=this.value; document.getElementById('bezBuild3').innerHTML=this.value; bez3.paint();"></td><td>1  (vrijednost t = <span id="bezBuild3">0</span>)</td></tr>
  </table>

<p>Krivulje koje smo dobivali u prethodnim primjerima nazivaju se <em>Aproksimacijske Bezierove krivulje</em>.</p>
<ul>
<li>Dvije točke određivale su aproksimacijsku Bezierovu krivulju 1. stupnja. Ta krivulja odgovara linijskom segmentu određenom zadanim točkama pri čemu segment započinje u prvoj a završava u drugoj.</li>
<li>Tri točke određivale su aproksimacijsku Bezierovu krivulju 2. stupnja. Uočite da je u skladu s konstrukcijom, ova krivulja zapravo linearna interpolacija između dvije aproksimacijske krivulje 1. stupnja.</li>
<li>Četiri točke određivale su aproksimacijsku Bezierovu krivulju 3. stupnja. Uočite da je u skladu s konstrukcijom, ova krivulja zapravo linearna interpolacija između dvije aproksimacijske krivulje 2. stupnja.</li>
<li>Priču možemo nastaviti, pa tako \(n+1\) točka određuje aproksimacijsku Bezierovu krivulju \(n\)-tog stupnja koja je linearna interpolacija između dvije aproksimacijske Bezierove krivulje \((n-1)\)-vog reda.</li>
</ul>

<p>Pogledajmo sada izraze koji su množili zadane radij-vektore.</p>

<table border="1">
<tr>
<th>Stupanj krivulje</th><th>Izrazi</th><th>Koeficijenti uz izraze</th>
</tr>
<tr>
<td>1</td><td align="center">\((1-t)\), \(t\)</td><td align="center">1, 1</td>
</tr>
<tr>
<td>2</td><td align="center">\((1-t)^2\), \((1-t) t\), \(t^2\)</td><td align="center">1, 2, 1</td>
</tr>
<tr>
<td>3</td><td align="center">\((1-t)^3\), \((1-t)^2 t\), \((1-t) t^2\), \(t^3\)</td><td align="center">1, 3, 3, 1</td>
</tr>
</table>

<p>
Sada možemo pogledati dobivene izraze i doći do općeg oblika parametarskog zapisa aproksimacijske Bezierove krivulje. Uočite redom:
</p>
<ol>
<li>Svi izrazi uz radij vektore oblika su \(t^{i} \cdot (1-t)^{n-i}\). Drugim riječima, suma eksponenata nad \(1-t\) i nad \(t\) uvijek odgovara stupnju krivulje \(n\).</li>
<li>Izrazi koje dobivamo s lijeva na desno kreću od maksimalne potencije nad \(1-t\) i završe s maksimalnom potencijom na \(t\).</li>
<li>Ako se jako koncentrirate na posljednji stupac, uočit ćete da koeficijenti koji množe izraze vizualno čine trokut s vrlo zanimljivim svojstvom: unutarnji elementi jednaki su sumi dva susjedna elementa iz retka iznad. Taj trokut naziva se Pascalov trokut i značajan je po tome što su mu elementi u \(n\)-tom retku upravo jednaki binomnim koeficijentima \(n\)-povrh-\(i\).</li>
</ol>

<p>Slijedi da je proizvoljna točka aproksimacijske Bezierove krivulje zadana sljedećim izrazom:
   \[
     \vec p(t) = \sum_{i=0}^{n} \binom{n}{i} \cdot t^i \cdot (1-t)^{n-i} \cdot \vec r_i
   \]
   pri čemu parametar \(t\) poprima vrijednosti iz intervala \([0,1]\). Funkcije koje pri tome
   množe pojedine radij-vektore (zadane točke) nazivaju se <em>Bernsteinove težinske funkcije</em> \(b_{n,i}(t)\),
   i definirane su kao:
   \[
     b_{n,i}(t) = \binom{n}{i} \cdot t^i \cdot (1-t)^{n-i}
   \]
   iz čega slijedi da je opći zapis aproksimacijske Bezierove krivulje dan kao suma
   umnožaka radij-vektora \(i\)-tog vrha kontrolnog poligona i odgovarajuće Bernsteinove
   težinske funkcije koja određuje koliki je utjecaj tog vrha na točku krivulje. Možemo 
   dakle kraće pisati:
   \[
     \vec p(t) = \sum_{i=0}^{n} b_{n,i}(t) \cdot \vec r_i .
   \]
</p>

